#ifndef _GRAB_FILE_H
#define _GRAB_FILE_H

enum file_type
{
	PLAIN_FILE,
	GZIP_FILE,
	LZMA_FILE
};

struct grab_data
{
	enum file_type type;
	unsigned long size;
	void *data;
};

/* Grab file.  Decompresses if that is supported.  Returns NULL on error. */
extern int grab_file(const char *filename, struct grab_data *fdata);

/* Free it up. */
extern void release_file(struct grab_data *fdata);

#endif /* _GRAB_FILE_H */
