/* Support for compressed modules.  Willy Tarreau <willy@meta-x.org>
 * did the support for modutils, Andrey Borzenkov <arvidjaar@mail.ru>
 * ported it to module-init-tools, and I said it was too ugly to live
 * and rewrote it 8).
 *
 * (C) 2003 Rusty Russell, IBM Corporation.
 */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include "grabfile_plain.h"
#include "logging.h"
#include "testing.h"

static int grab_fd(int fd, struct grab_data *fdata)
{
	struct stat st;
	int ret;

	ret = fstat(fd, &st);
	if (ret < 0)
		return -1;
	fdata->size = st.st_size;
	fdata->data = mmap(0, fdata->size, PROT_READ|PROT_WRITE, MAP_PRIVATE, fd, 0);
	if (fdata->data == MAP_FAILED)
		fdata->data = NULL;
	return 0;
}

int plain_grab_file(const char *filename, struct grab_data *fdata)
{
	int fd;

	fd = open(filename, O_RDONLY, 0);
	if (fd < 0)
		return -1;
	if (grab_fd(fd, fdata) < 0)
		return -1;
	fdata->type = PLAIN_FILE;
	close(fd);
	return 0;
}

void plain_release_file(struct grab_data *fdata)
{
	munmap(fdata->data, fdata->size);
}
